		(* Mines 97: macro-expansions *)
let tableMax=128;;

type macro_definition= {Symbole:string; Definition:string};;

let EntreeVide={Symbole="";Definition=""};;

type 'a table_des_symboles = {
	Table: 'a vect;
 	mutable TailleTable:int }
;;

let TableDesSymboles= {
	Table=make_vect tableMax EntreeVide;
	TailleTable=0}
;;
	
let nouvelle_entree symbole definition=
	let n=TableDesSymboles.TailleTable in
	if n=tableMax
	then failwith "la table est pleine"
	else begin
		TableDesSymboles .TailleTable<-(n+1);
		TableDesSymboles.Table.(n)<- {Symbole=symbole;Definition=definition};
	       end
;;

nouvelle_entree "Info" "Informatique";;

nouvelle_entree "Permute" "$2$1";;

let estDansTable s=
	let trouve=ref false and k=ref (-1) in
	while ((not !trouve) & (!k<TableDesSymboles.TailleTable-1))
	do  incr k;trouve:=(s=TableDesSymboles.Table.(!k).Symbole)	done;
	!trouve
;;

let defDansTable s=
	let trouve=ref false and k=ref (-1) in
	while ((not !trouve) & (!k<TableDesSymboles.TailleTable-1))
	do  	incr k;
		trouve:=(s=TableDesSymboles.Table.(!k).Symbole)	;
	done;
	if !trouve
	then TableDesSymboles.Table.(!k).Definition
	else failwith "symbole inconnu de la TDS"
;;

(* programmation de la recherche dichotomique dans un tableau tri *)
let cherchedicho ordre tableau element=
	let rec souscherche min max=
	if max<=min+1
	then let p=tableau.(min) and g=tableau.(max) in
		if (element = p)
		then 	begin print_string"trouv: ";print_int min end
		else	if (element=g)
			then begin print_string"trouv: ";print_int max end
			else print_string"perdu "
	else let milieu=(min+max)/2 in
		if ordre tableau.(milieu) element
		then souscherche milieu max
		else souscherche min (milieu-1)
	in souscherche 0 (vect_length tableau -1)
;;
	
#open "sort";;

(* j'avais d'abord mis lt_string comme ordre, et bien entendu on n'y voyait plus rien, toutes les entres vide taient au dbut *)
let triTable=
	let atrier=TableDesSymboles.Table in 
	let monordre u v= gt_string u.Symbole v.Symbole in
	vect_of_list (sort  monordre (list_of_vect atrier));;

(* 
il reste  
1) recopier triTable dans TableDesSymboles.Table, 
2) dfinir "avant=gt_string"
3) recopier defDansTable et estDansTable en defDansTabledicho s et idem 
*)
