(** Promenade alatoire dans un carr avec effet de plasma ...**)




(* Quelques utilitaires *)
#open "graphics";;
#open "random";;
init (int_of_float (sys__time()));;

let plasma_color=0x101000;;

let trace (x,y) =
let c=point_color (x+size_x()/2) (y+size_y()/2)
in
(
 if c<plasma_color then set_color 0x0000FF else set_color (c-plasma_color);
 plot (x+size_x()/2) (y+size_y()/2)
);;

let draw_rect x y w h = 
	moveto x y;
	lineto (x+w) y; 
	lineto (x+w) (y+h);
	lineto x (y+h);
	lineto x y
;;

let augmente (x,y) = function
	|0 -> (x+1,y)
	|1 -> (x,y+1)
	|2 -> (x-1,y)
	|3 -> (x,y-1)
	|_ -> (x,y)
;;

let norme (x,y) = max (abs x) (abs y);;

(* Le programme de dessin *)
let marche dim =
	let it=ref 0 and pt=ref (0,0)
in	open_graph "";
	draw_rect (size_x()/2-dim) (size_y()/2-dim) (2*dim) (2*dim);
	while norme !pt < dim do
		trace !pt;
		pt:=augmente !pt (int 4);
		incr it;
	done;
	set_color black;
	moveto 2 (size_y()/2 -9); draw_string ((string_of_int !it)^" itrations");
	print_newline();
	print_int !it; print_string " itrations\n";
;;

marche 300;;

(* Calcul de la moyenne du nombre d'itrations *)
let moyenne nbre dim =
	let result=ref 0
	and go n =
		let it=ref 0 and pt=ref (0,0)
	in	while norme !pt < n do
			pt:=augmente !pt (int 4);
			incr it;
		done;
		!it
in	for t=0 to nbre do result:= !result + (go dim) done;
	print_float ((float_of_int !result)/.(float_of_int nbre)); print_string " itrations\n";
	
;;

moyenne 1000 100;; (* Donne 11700 *) 


