(* Exponentiation rapide *)

let rec puissance x n=
	if n mod 2 =0
	then 	if n=0 
		then 1
		else (a*a where a=puissance x (n quo 2))
	else (x*(a*a) where a=puissance x (n quo 2))
;;
(*trace "puissance";;*)
puissance 2 10;;


(* toujours le mme, mais en itratif*)
(*un invariant pour une preuve de programme est le triplet (pui,base,n) qui vrifie tout du long pui*base^n=x^n *)
let puissiter x exp=
	let pui = ref 1
	and base = ref x
	and n	= ref exp
in	while !n>0 
	do if !n mod 2=0 
		then (n:=!n/2; base:=!base*(!base))
		else (n:=!n-1; pui:=!pui*(!base))
	done;
	!pui
;;

(* Exponentiation rapide avec dcomposition binaire *)
let rec intabin n l=match n with
	|0->l
	|n->	if n mod 2= 0
		then intabin (n quo 2) (0::l) 
		else intabin ((n-1) quo 2) (1::l)
;;

let i_bin  n= if n=0 then [0] else intabin n [];;

let rec puissance x l=match l with 
	|([]|[0])->1
	|0::m->puissance (x*x) m
	|1::m->x*puissance (x*x) m
;;

let vrai x l=puissance x (rev l);;
