	(*commande range*)

(* fabrication imperative de range*)
let range p q=
	if q==p 
	then [|p|]
	else 	if q>p
		then let nul=make_vect (q-p+1) 0 in 
		     for k=0 to (q-p) do nul.(k)<-(k+p) done; nul
		else let nul = make_vect (p-q+1) 0 in
		     for k=0 to (p-q) do nul.(k)<-(p-k) done; nul
	;;

(*--------------------------------------*)
(*confection fonctionelle de range (pour p<q)*)
let rangef p q=
	let nul=make_vect (q-p+1) p in 
	let rec met k= if k>q
		then ()
		else begin 
			nul.(k-p)<-(1+nul.(k-p-1));
			met (k+1)
		        end in
	met (p+1); nul;;

(*confection de range par listes *)
(* version rcursive prfixe*)
let rec range_pref p q=
	if q=p 
	then [q]
	else p::(range_pref (p+1) q)
;;

(* version rcursive postfixe*)
let rec range_post p q=
	if p=q 
	then [p]
	else (range_post p (q-1))@[q]
;;

(*version itrative postfixe*)
let range_it_post p q=
	let fini=ref [p] in
	for k= p+1 to q do fini:=!fini@[k] done;
	!fini
;;

(*version itrative prfixe*)
let range_it_pre p q=
	let fini=ref [q] in
	for k= q-1 downto p do fini:=k::!fini done;
	!fini
;;

(*version itrative prfixe, avec retour aux tableaux*)
let range_it_pre_retab p q=
	let fini=ref [q] in
	for k= q-1 downto p do fini:=k::!fini done;
	vect_of_list !fini
;;

(* il faut faire cela 10000 fois et chronomtrer*)

for k=1 to 10000 do range_it_pre 5 14 done;;

(*l'xcution qui suit met 15 secondes sur mon DX-33: une incrmentation de compteur dure donc 1.510^(-5)
sur un P166 elle a dur 15s mais avec 10 000 000 *)
let vide=for k=1 to 1000000 do done;;

(*l'xcution qui suit met 6 secondes sur mon DX-33*)
let test_range1=for k=1 to 1000 do range 1 100 done;;

(*l'xcution qui suit met 6  secondes sur mon DX-33*)
let test_range1=for k=1 to 100 do range 1 1000 done;;

(*l'xcution qui suit met 8  secondes sur mon DX-33*)
let test_rangef1=for k=1 to 100 do rangef 1 1000 done;;

(*l'xcution qui suit met  8 secondes sur mon DX-33*)
let test_rangef1=for k=1 to 100 do rangef 1 1000 done;;

(*l'xcution qui suit met  3 secondes sur mon DX-33*)
let test_range_pref1=for k=1 to 100 do range_pref 1 1000 done;;

(*l'xcution qui suit a t arrte aprs 1 minute sur mon DX-33*)
let test_range_post=for k=1 to 100 do range_post 1 1000 done;;

(*l'xcution qui suit a t arrte aprs 1 minute sur mon DX-33*)
let test_range_post=for k=1 to 1000 do range_post 1 100 done;;

(*l'xcution qui suit met 12 secondes sur mon DX-33*)
let test_range_post=for k=1 to 10000 do range_post 1 10 done;;

(*l'xcution qui suit met 48 secondes sur mon DX-33 (promis, je ne triche pas)*)
let test_range_post=for k=1 to 10000 do range_post 1 20 done;;

(*l'xcution qui suit met "trop longtenps "*)
let test_range_it_post=for k=1 to 1000 do range_post 1 100 done;;

(*l'xcution qui suit met 13s *)
let test_range_it_post=for k=1 to 10000 do range_post 1 10 done;;

(*l'xcution qui suit met 2s *)
let test_range_it_pre=for k=1 to 1000 do range_it_pre 1 100 done;;

(*version itrative prfixe, avec retour aux tableaux*)
let range_it_pre_retab p q=
	let fini=ref [q] in
	for k= q-1 downto p do fini:=k::!fini done;
	vect_of_list !fini
;;

(*ce qui suit a pris 3 secondes, la fonction vect_of_list est donc trs bonne*)
let test_range_it_pre=for k=1 to 1000 do range_it_pre 1 100 done;;
