(*----------------typ ab: arbres binaires style crit E.N.S. 97----------------*)
type ab =  |Feuille 
                 |Noeud of ab*ab;; 

(*   des mthodes associes avec le type ab *)
let un_exemple=
Noeud(Noeud(Noeud(Feuille,Noeud(Feuille,Feuille)),Feuille),Feuille);;

let est_une_feuille=fun a->(a=Feuille);; 

let fils_gauche a=match a with 
              |Feuille -> failwith "une feuille ne peut tre pre" 
              |Noeud (g,d)->g ;; 

fils_gauche un_exemple;;

let fg=fils_gauche;;
est_une_feuille (fg (fg un_exemple));;
est_une_feuille (fg (fg (fg un_exemple)));;

(* les exemples du cours *)
let nouveau_pere_ab arbre=Noeud (arbre,Feuille);;	
nouveau_pere_ab un_exemple;;

let rec fils_a_droite = fun 
	|Feuille->Noeud (Feuille,Feuille)
	|(Noeud (fg,fd))->Noeud (fg, fils_a_droite fd)
;;
fils_a_droite (fils_a_droite Feuille);;
(* faute de Noeuds  une feuille c'est peu satisfaisant *)

(*-------type ('F,'N) arbre : arbres genre Monasse ------------------------- *)
type ('F,'N) arbre =
              |Feuille of  'F 
              |Noeud of 'N*('F,'N) foret 
and ('F,'N) foret= 
	    Branches of ('F,'N) arbre list;;	


(*  des mthodes associes aux ('F,'N) arbre *)
let exemple1=Noeud (`a`,Branches [Noeud (`z`,Branches []);Feuille 456]);;
	
let exemple2=Noeud (17,Branches [Noeud (-300,Branches []);Feuille 0.126]);;

let racine = function
	|Feuille f -> f
	|Noeud (x,_) -> x
;; 

(* exemple1 est typ par caml comme exemple1 : (int, char) arbre, exemple2 est ensuite reconnu comme exemple2 : (float, int) arbre, enfin racine est type comme racine : ('a, 'a) arbre -> 'a = <fun> *)
 
(* ----- type ('F,'N) arbre : arbres genre Monasse  + type OU ---------- *)
type ('F,'N) arbre =
              |Feuille of  'F 
              |Noeud of 'N*('F,'N) foret 
and ('F,'N) foret= 
	    Branches of ('F,'N) arbre list;;	

(*  des mthodes associes aux ('F,'N) arbre *)
type multi = R of float|N of int;;

let exemple1=Noeud (`a`,Branches [Noeud (`z`,Branches []);Feuille 456]);;
	
let exemple2=Noeud (17,Branches [Noeud (-300,Branches []);Feuille 0.126]);;

let racine = function
	|Feuille f -> (R f)
	|Noeud (x,_) -> (N x)
;; 

exception Trouv;;
let cherche arbre reel=
	let rec acherche = function
		|(Feuille f)->if (f=reel) then raise Trouv;
		|(Noeud (n,foret))->bcherche foret 
	and bcherche = function
		|(Branches [])	->	()
		|(Branches (t::q)) -> (acherche t ;	bcherche (Branches q))
in try (acherche arbre ; print_string "pas de feuille")
	with Trouv->print_string "la feuille tait bien l"
;;

cherche exemple2 0.126789;;
pas de feuille- : unit = ()

cherche exemple2 0.126;;
la feuille tait bien l- : unit = ()

(*----------type abs: les arbres de mes exemples ---------------------------- *)
(* 	Les abs sont des arbres binaires de strings, c'est le type que j'utilise dans les exemples d'affichage d'arbre *)
type abs =
	|Nil 
	|Feuille of string 
	|Noeud of abs*string*abs;; 

(*  des mthodes associes aux abs *)	
let ex_str1=Noeud (Noeud(Feuille "7","toto",Nil),"ci",Nil);;

let rec concat un_abs=match un_abs with 
              |Nil->"_" 
              |Feuille s->s 
              |Noeud (g,c,d) ->(concat g)^"*"^c^"*"^(concat d) 
;;

(* une fonction qui entre une chane de caractres dans un arbre en la triant 
La fonction etale vient des cours sur les tris
les tris de "le tri par arbre" donnent des rsultats trs diffrents selon que l'on utilise le_string ou lt_string *)

let etale s=
	let long=string_length s in
	let tab=make_vect long "a" in
	for k=0 to long-1 do tab.(k)<-make_string 1 (nth_char s k) done;
	tab;;

let arbrifie chaine=
	let rec ajoute arbre car=match arbre with
		|Nil->Feuille car
		|Feuille f-> if  le_string car f
						 then Noeud (Feuille car,f,Nil)
						 else  Noeud (Nil,f,Feuille car)
		|Noeud (g,p,d)-> if le_string car p
							  then Noeud (ajoute g car,p,d)
							  else Noeud (g,p,ajoute d car)
in	let rec ajouteliste arbre = function
		|[]->arbre
		|t::q->ajouteliste (ajoute arbre t) q
	in ajouteliste Nil (list_of_vect (etale chaine))
;; 

let rec cherche unmot =	function
          |Nil -> false
          |(Feuille f) -> (unmot=f)
          |(Noeud (fg,p,fd)) -> (unmot=p) or
                               if lt_string unmot p
                               then cherche unmot fg
                               else cherche unmot fd
;;

let rec insere unmot = function
	|Nil->(Feuille unmot)
	|(Feuille f)-> if unmot < f
                  then (Noeud (Feuille unmot,f,Nil))
                  else (Noeud (Nil,f,Feuille unmot))
	|(Noeud (fg,p,fd))->	if unmot < p
                        then (Noeud (insere unmot fg,p,fd))
								else (Noeud (fg,p,insere unmot fd))
;;


(* pour crer des abs, on pourra utiliser iag (resp iad) qui inserent dans arbrepere un arbrefils qui sera fils de la feuille la plus  gauche (resp la plus  droite) *)
let rec iag ap af=match ap with
	|Nil->af
	|Feuille f->Noeud(af,f,Nil)
	|Noeud (g,c,d)->Noeud((iag g af),c,d)
;;

let rec iad ap af=match ap with
	|Nil->af
	|Feuille f->Noeud(Nil,f,af)
	|Noeud (g,c,d)->Noeud(g,c,(iad d af))
;;

let a2= iag ex_str1 ex_str1;;
let a3= iad ex_str1 ex_str1;;

let rec hauteur_abs=fun
	|Nil	->	0
	|(Feuille f)	->	0
	|(Noeud (g,c,d))	->	1+(max (hauteur_abs g) (hauteur_abs d))
;;


(* ----- type repertoire: des arbres  descendance variable --------------- *)
(* Enfin un arbre avec un nombre variable de fils pouvant modliser un disque dur *)
type repertoire =
	|Nil
	|Fichier of string
	|Noeud of (string*(repertoire list)) 
;; 	

(* attention: entr tel quel dans caml le type n'est pas reconnu, c'est =| qui est rejet, en mettant le |Nil  la ligne du dessous, tout passe *)

(* un rpertoire-exemple *)
let rep1=Noeud ("racine",
		[	Fichier "cours";
			Fichier "TD";
			Noeud ("divers",[	Fichier"TIPE";
					Fichier "colles"]
			)
		]
	);;

let cree rep sousrep soussousrep=
	let rec ajoute = function
		|Nil	->	Nil
		|Fichier f -> Fichier f
		|Noeud(nom,liste) ->
			if nom=sousrep
			then Noeud(nom,Noeud(soussousrep,[])::liste)
			else Noeud(nom,map ajoute liste)
	in ajoute rep;;

cree rep1 "divers" "erreurs";;

(* ----------------------------type maximier ---------------------------------- *)
type max =
	|Nil
	|Feuille of string
	|Noeud of  max*string*max
;;

#open "random";;
init (int_of_float (sys__time()));;

let valeur = function
	|(Noeud (_,p,_))->p 
	|(Feuille f)->f 
	|_ -> failwith "valeur Nil";;

let rec etete = function
	|Nil ->	failwith "jivaro deu"
	|Feuille f -> Nil
	|Noeud(Nil,_,Feuille f) -> Feuille f
	|Noeud(Nil,_,fd) -> Noeud(Nil, valeur fd, etete fd)
	|Noeud(Feuille f,_,Nil) -> Feuille f
	|Noeud(fg,_,Nil) -> Noeud (etete fg, valeur fg, Nil)
	|Noeud (fg,p,fd) -> 
		if ((valeur fg) < (valeur fd))
		then (Noeud (fg, (valeur fd), (etete fd)))
		else (Noeud ((etete fg), (valeur fg), fd))
;;

let rec nouveau file client=
	match file with
		|Nil		->	Feuille client
		|(Feuille f)	->	if client > f
					then 	if (int 2 =0)
						then 	Noeud (Feuille f,client,Nil)
						else  	Noeud (Nil,client,Feuille f)
					else	if (int 2 = 0)
						then	Noeud (Feuille client, f, Nil)
						else	Noeud (Nil, f, Feuille client)
		|(Noeud (g,p,d))->	if client > p
					then 	if (int 2 =0)
						then 	Noeud (nouveau g p,client,d)
						else  	Noeud (g ,client,nouveau d p)
					else	if (int 2 = 0)
						then	Noeud (nouveau g client, p, d)
						else	Noeud (g, p, nouveau d client)
;;


(* conversion string -> listes de caractres (MonoString) *)
let etale s=
	let long=string_length s in
	let tab=make_vect long "a" in
	for k=0 to long-1 do tab.(k)<-make_string 1 (nth_char s k) done;
tab;;

let test=it_list nouveau Nil (list_of_vect (etale "file de priorit"));;

#open "graphics";;

let h= -30;;
let trait xd yd xf yf=moveto xd yd;lineto xf yf;;

let rec affiche arbre xmin xmax y =
	let xcentre=(xmin+xmax)/2
in	match arbre with
		|Nil->()
		|Feuille f->(moveto xcentre y; draw_string f)
		|Noeud (g,p,d)-> 
			begin 
			moveto xcentre y; draw_string p;
			if g != Nil then
				begin
				trait xcentre (y+h) ((xmin+xcentre)/2) (y+h+h);
				affiche g  xmin xcentre (y+h+h)
				end;
			if d != Nil then
				begin
				trait xcentre (y+h) ((xmax+xcentre)/2) (y+h+h);
				affiche d xcentre xmax (y+h+h)
				end;
			end;
;;

let fait_voir arbre=affiche arbre  0 (size_x()) (size_y() -20);;
open_graph ""; fait_voir test;; 
