(* Rsolution de trinmes  coefficients complexes *)
(***************************************************)


(* Dfinition des oprations dans les complexes *)
type Complexe=C of (float*float);;

let Re z=match z with C(x,_)->x;;
let Im z=match z with C(_,x)->x;;
let Conj z=C(Re(z), (-.Im(z)));;
let Moducar z=Re(z)*.Re(z) +. Im(z)*.Im(z);;

#uninfix "plus";;
#uninfix "moins";;
#uninfix "fois";;
#uninfix "divi";;

let plus x y=C(Re(x)+.Re(y), Im(x)+.Im(y));;
#infix "plus";;

let moins x y=C(Re(x)-.Re(y), Im(x)-.Im(y));;
#infix "moins";;

let fois x y=C(Re(x)*.Re(y)-.Im(x)*.Im(y), Re(x)*.Im(y)+.Re(y)*.Im(x));;
#infix "fois";;

let divi x y= let a=x fois (Conj y) in C(Re(a)/.(Moducar y),Im(a)/.(Moducar y));;
#infix "divi";;

(*let Arg z=let r=sqrt(Moducar z) in
	if Re(z)>=.0. then if Im(z)>=0. then asin(Im(z)/.r)
					else -.acos(Re(z)/.r)
	else if Im(z)>=0. then acos(Re(z)/.r)
			else -.acos(Re(z)/.r);;*)

(* ou, ici Arg(z) est dans ]-Pi;Pi] *)
let Arg x = let z=x divi (C(sqrt(Moducar x),0.)) in
	if Re(z)= -1. then 4.*.atan(1.)
	else 2.*.atan(Im(z)/.(Re(z)+.1.))
;;

let Racine z=let r=sqrt(sqrt(Moducar z)) and t=(Arg z)/.2. in C(cos(t)*.r,sin(t)*.r);;

(* Programme principal *)
let sol_trinome a b c=
	let delta = (b fois b) moins ((C(4.,0.) fois a) fois c) in
	if a=C(0.,0.)
	then if b=C(0.,0.)
		  then if c=C(0.,0.)
        		 then failwith "Une infinit de solution dans C"
				 else failwith "Pas de solution"
		  else [(C(0.,0.) moins c) divi b]
	else if delta = C(0.,0.)
		  then [C(0.,0.) moins (b divi (C(2.,0.) fois a));
        		  C(0.,0.) moins (b divi (C(2.,0.) fois a))]
      else [((C(0.,0.) moins b) plus (Racine delta)) divi (C(2.,0.) fois a);
				((C(0.,0.) moins b) moins (Racine delta)) divi (C(2.,0.) fois a)];;

(* Quelques exemples *)
sol_trinome (C(1.,0.)) (C(-.2.,0.)) (C(1.,0.));;
sol_trinome (C(1.,0.)) (C(-.1.,0.)) (C(-.1.,0.));;
sol_trinome (C(1.,0.)) (C(1.,0.)) (C(1.,0.));;
sol_trinome (C(1.,1.)) (C(1.,2.)) (C(1.,0.));;
